unit MYEDITU;

interface

uses
  Printers, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Bevel1: TBevel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    FontDialog1: TFontDialog;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrintDialog1: TPrintDialog;
    FindDialog1: TFindDialog;
    ReplaceDialog1: TReplaceDialog;
    Button8: TButton;
    Button9: TButton;
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FontDialog1Apply(Sender: TObject; Wnd: HWND);
    procedure Button5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button4Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
with OpenDialog1 do
  if Execute then
  begin
    Memo1.Lines.LoadFromFile(Filename);
    HistoryList.Add(Filename);
    Caption := '  - ' + ExtractFilename(Filename);
    SaveDialog1.Filename := Filename;
    Filename := ' ';
  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Memo1.Lines.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  with SaveDialog1 do
  if Execute then
  begin
    Memo1.Lines.SaveToFile(Filename);
    Caption := '  - ' + ExtractFilename(Filename);
  end;

end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  with FontDialog1 do
if Execute then
  Memo1.Font := Font;
end;

procedure TForm1.FontDialog1Apply(Sender: TObject; Wnd: HWND);
begin
  Memo1.Font := FontDialog1.Font;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  POutput : TextFile;
  N : LongInt;
begin
  if PrintDialog1.Execute then
  begin
   AssignPrn(POutput);
    Rewrite(POutput);
    Printer.Canvas.Font := Memo1.Font;
    for N := 0 to Memo1.Lines.Count - 1 do
      Writeln(POutput, Memo1.Lines [N]);
    CloseFile(POutput);
  end;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  FindDialog1.Execute;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  ReplaceDialog1.Execute;
end;

procedure TForm1.FindDialog1Find(Sender: TObject);
var
  Buff, P, FT : PChar;
  BuffLen : Word;
begin
  with Sender as TFindDialog do
    begin
      GetMem(FT, Length(FindText) + 1);
      StrPCopy(FT, FindText);
      BuffLen := Memo1.GetTextLen + 1;
      GetMem(Buff, BuffLen);
      Memo1.GetTextBuf(Buff, BuffLen);
      P := Buff + Memo1.SelStart + Memo1.SelStart + Memo1.SelLength;
      P := StrPos(P, FT);
      if P = NIL then MessageBeep(0)
      else
        begin
          Memo1.SelStart := P - Buff;
          Memo1.SelLength := Length(FindText);
        end;
      FreeMem(FT, Length(FindText) + 1);
      FreeMem(Buff, BuffLen);
    end;
end;

procedure TForm1.ReplaceDialog1Replace(Sender: TObject);
begin
with Sender as TReplaceDialog do
  while True do
    begin
      if Memo1.SelText <> FindText then
        FindDialog1Find(Sender);
      if Memo1.SelLength = 0 then Break;
      Memo1.SelText := ReplaceText;
      if NOT (frReplaceAll IN Options) then Break;
    end;
end;

end.
